import es
import playerlib, popuplib, gamethread, random, cfglib

config = cfglib.AddonCFG(es.getAddonPath('hidden') + '/hidden.cfg')

config.text('**************************')
config.text(' -> Hidden Config File <- ')
config.text('**************************')
hidden_health = config.cvar('hidden_health', 250, 'How many HP should the Hidden get?')
additional_hidden_health = config.cvar('additional_hidden_health', 3, 'hidden_health / additional_hidden_health = HP that the hidden gains if he kills somebody')
hidden_speed = config.cvar('hidden_speed', 1.3, 'How fast should the Hidden be? (1.0 = normal, 1.3 = Hidden Standard, higher than that = almost impossible for one CT to kill the Hidden)')
hidden_class = config.cvar('hidden_class', 10, 'Set the duration a player can change his/her class')
dark_mode = config.cvar('dark_mode', 1, '0 = Darker than normal, 1 = very dark')

config.write()

rank_menu = 0
rank_menu_iris = 0
rank_menu_hidden = 0
classes = 0
secondary = 0
assault = 0
support = 0
addition = 0
msg = 0
new_class = 0
bot_wep_prim = ('weapon_tmp;weapon_famas;weapon_mp5navy;weapon_m3;weapon_xm1014')
bot_wep_sec = ('weapon_p228;weapon_fiveseven')
sounds = ('hidden/617-radiotaunts08.mp3', 'hidden/617-radiotaunts01.mp3', 'hidden/617-radiotaunts06.mp3')
death_hidden = ('hidden/617-death01.mp3', 'hidden/617-death05.mp3')
death_iris = ('hidden/IRIS-death14.wav', 'hidden/IRIS-death04.wav')
chosen = {}
ranks = {}

def load():
    global assault, support, classes, secondary, addition, rank_menu, rank_menu_iris, rank_menu_hidden
    config.execute()
    es.ServerVar('ES Hidden', '2.0 ESP').makepublic()
    rank_menu = popuplib.easymenu('ranks', '_popup_choice', rank_men)
    rank_menu.settitle('Choose Rank for Hidden or IRIS')
    rank_menu.addoption('hidden', 'Hidden')
    rank_menu.addoption('iris', 'IRIS')
    rank_menu_iris = popuplib.easymenu('iris_ranks', None, None)
    rank_menu_iris.settitle('Rank as IRIS')
    rank_menu_iris.addoption('kills', 'Kills: 0')
    rank_menu_iris.addoption('deaths', 'Deaths: 0')
    rank_menu_hidden = popuplib.easymenu('hidden_ranks', None, None)
    rank_menu_hidden.settitle('Rank as Hidden')
    rank_menu_hidden.addoption('kills', 'Kills: 0')
    rank_menu_hidden.addoption('deaths', 'Deaths: 0')
    rank_menu_hidden.addoption('times', 'Spawned as Hidden: 0 Times')
    classes = popuplib.easymenu('wep_menu', '_popup_choice', class_men)
    classes.settitle('Choose a Class')
    classes.setdescription('Assault: Less Health, more powerful Weapons\nSupport: More Health, less powerful Weapons')
    classes.addoption('assault', '[ ] Assault')
    classes.addoption('support', '[ ] Support')
    assault = popuplib.easymenu('assault_menu', '_popup_choice', assault_men)
    assault.settitle('Choose a Primary Weapon')
    assault.addoption('famas', '[ ] FN2000 Assault Rifle (FAMAS)')
    assault.addoption('mp5navy', '[ ] FN Navy 3200 Sub Machine Gun  (MP5Navy)')
    assault.addoption('m3', '[ ] Remington 870 MCS Shotgun (M3)')
    assault.addoption('xm1014', '[ ] FN303 Less Lethal Launcher (XM1014)')
    support = popuplib.easymenu('support', '_popup_choice', support_men)
    support.settitle('Choose a Primary Weapon')
    support.addoption('mp5navy', '[ ] FN Navy 3200 Sub Machine Gun  (MP5Navy)')
    support.addoption('tmp', '[ ] FN Tactial Machine Gun  (TMP)')
    support.addoption('xm1014', '[ ] FN303 Less Lethal Launcher (XM1014)')
    secondary = popuplib.easymenu('sec', '_popup_choice', sec_men)
    secondary.settitle('Choose a Secondary Weapon')
    secondary.addoption('fiveseven', '[ ] FN FiveSeven Pistol (Fiveseven)')
    secondary.addoption('p228', '[ ] FNP-9 Pistol (P228)')
    addition = popuplib.easymenu('addition', '_popup_choice', hidden_add)
    addition.settitle('Choose an Equipment')
    addition.addoption('nvgs', '[ ] Light Amplification Goggles (NVGs)')
    downloads()
    if not es.exists('saycommand', '!class'):
        es.regsaycmd('!class', 'hidden/class_send')
    if not es.exists('saycommand', 'rank'):
        es.regsaycmd('rank', 'hidden/rank_player')
    for userid in playerlib.getUseridList('#human'):
        user = playerlib.uniqueid(userid, True)
        if not user in chosen:
            default(user)
        if not user in ranks:
            rank(user)

def unload():
    global assault, classes, support, secondary, addition, chosen
    assault.delete()
    classes.delete()
    support.delete()
    secondary.delete()
    addition.delete()
    es.unregsaycmd('!class')
    es.unregsaycmd('rank')
    chosen.clear()
    for userid in playerlib.getUseridList('#human'):
        es.server.queuecmd('es_xfire %s func_buyzone Enable' % userid)
        es.server.queuecmd('es_xfire %s func_bomb_target Enable' % userid)
        es.server.queuecmd('es_xfire %s func_hostage_rescue Enable' % userid)

def rank_men(userid, choice, popupid):
    global rank_menu_hidden, rank_menu_iris
    user = playerlib.uniqueid(userid, True)
    kills = ranks[user]['kills']
    deaths = ranks[user]['deaths_hidden']
    deaths_iris = ranks[user]['deaths_iris']
    kills_iris = ranks[user]['kills_iris']
    hidden_times = ranks[user]['hidden_times']
    if choice == 'hidden':
        if kills == 0 and deaths == 0 and hidden_times == 0:
            es.tell(userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultYou\'re not ranked as a #greenHidden #defaultyet!')
        elif kills > 0:
            rank_menu_hidden.setoption('kills', 'Kills: %s' % kills)
            rank_menu_hidden.send(userid)
        elif deaths > 0:
            rank_menu_hidden.setoption('deaths', 'Deaths: %s' % deaths)
            rank_menu_hidden.send(userid)
        elif kills > 0 and deaths > 0:
            rank_menu_hidden.setoption('deaths', 'Deaths: %s' % deaths)
            rank_menu_hidden.setoption('kills', 'Kills: %s' % kills)
            rank_menu_hidden.send(userid)
        elif hidden_times > 0:
            rank_menu_hidden.setoption('times', 'Spawned as Hidden: %s Times' % hidden_times)
            rank_menu_hidden.send(userid)
        elif kills > 0 and deaths > 0 and hidden_times > 0:
            rank_menu_hidden.setoption('deaths', 'Deaths: %s' % deaths)
            rank_menu_hidden.setoption('kills', 'Kills: %s' % kills)
            rank_menu_hidden.setoption('times', 'Spawned as Hidden: %s Times' % hidden_times)
            rank_menu_hidden.send(userid)
    elif choice == 'iris':
        if kills_iris == 0 and deaths_iris == 0:
            es.tell(userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultYou\'re not ranked as a #greenIRIS Force #defaultyet!')
        elif kills_iris > 0:
            rank_menu_iris.setoption('kills', 'Kills: %s' % kills_iris)
            rank_menu_iris.send(userid)
        elif deaths_iris > 0:
            rank_menu_iris.setoption('deaths', 'Deaths: %s' % deaths_iris)
            rank_menu_iris.send(userid)

def es_map_start(ev):
    downloads()

def downloads():
    es.stringtable('downloadables', 'sound/hidden/617-death01.mp3')
    es.stringtable('downloadables', 'sound/hidden/617-death05.mp3')
    es.stringtable('downloadables', 'sound/hidden/617-radiotaunts01.mp3')
    es.stringtable('downloadables', 'sound/hidden/617-radiotaunts06.mp3')
    es.stringtable('downloadables', 'sound/hidden/617-radiotaunts08.mp3')
    es.stringtable('downloadables', 'sound/hidden/IRIS-death04.wav')
    es.stringtable('downloadables', 'sound/hidden/IRIS-death14.wav')
    es.stringtable('downloadables', 'sound/hidden/IRIS-roundend06.wav')
    es.stringtable('downloadables', 'sound/hidden/IRIS-roundstart02.wav')

def rank_player():
    userid = es.getcmduserid()
    rank_menu.send(userid)

def class_send():
    userid = es.getcmduserid()
    if es.getplayersteamid(userid) != 'BOT':
        user = playerlib.uniqueid(userid, True)
        if es.getplayerteam(userid) in [1, 3]:
            if new_class == 1:
                default(user)
                classes.send(userid)
            else:
                es.tell(userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultYou can only change your class within #lightgreen%s #defaultseconds!' % hidden_class)
        else:
            es.tell(userid, '#multi', '#green[#lightgreenES Hidden#green] Hidden #lightgreencan\'t change its class!')

def hidden_add(userid, choice, popupid):
    global chosen
    if es.getplayersteamid(userid) != 'BOT':
        user = playerlib.uniqueid(userid, True)
        if choice == 'nvgs':
            chosen[user]['addition'] = 'nvgs'
            es.server.queuecmd('est_Team %s 3' % userid)
            es.server.queuecmd('est_Spawn %s 1' % userid)
            es.tell(userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultPress #greenN #defaultto turn on #lightgreenLight Amplification Goggles')

def sec_men(userid, choice, popupid):
    global chosen
    if es.getplayersteamid(userid) != 'BOT':
        user = playerlib.uniqueid(userid, True)
        if choice == 'p228':
            chosen[user]['sec'] = 'weapon_p228'
        elif choice == 'fiveseven':
            chosen[user]['sec'] = 'weapon_fiveseven'
        addition.send(userid)

def assault_men(userid, choice, popupid):
    global chosen
    if es.getplayersteamid(userid) != 'BOT':
        user = playerlib.uniqueid(userid, True)
        if choice == 'famas':
            chosen[user]['prim'] = 'weapon_famas'
        elif choice == 'mp5navy':
            chosen[user]['prim'] = 'weapon_mp5navy'
        elif choice == 'm3':
            chosen[user]['prim'] = 'weapon_m3'
        elif choice == 'xm1014':
            chosen[user]['prim'] = 'weapon_xm1014'
        secondary.send(userid)

def support_men(userid, choice, popupid):
    global chosen
    if es.getplayersteamid(userid) != 'BOT':
        user = playerlib.uniqueid(userid, True)
        if choice == 'mp5navy':
            chosen[user]['prim'] = 'weapon_mp5navy'
        elif choice == 'tmp':
            chosen[user]['prim'] = 'weapon_tmp'
        elif choice == 'xm1014':
            chosen[user]['prim'] = 'weapon_xm1014'
        secondary.send(userid)

def class_men(userid, choice, popupid):
    global chosen
    user = playerlib.uniqueid(userid, True)
    if choice == 'assault':
        chosen[user]['class'] = 'assault'
        assault.send(userid)
    elif choice == 'support':
        chosen[user]['class'] = 'support'
        support.send(userid)

def round_start(ev):
    global new_class, ranks
    if dark_mode == 1:
        es.lightstyle(0, 'a')
    else:
        es.lightstyle(0, 'b')
    es.server.queuecmd('est_RemoveIdle cs_ragdoll')
    es.server.queuecmd('est_RemoveIdle weapon')
    new_class = 1
    gamethread.delayed(hidden_class, declass, ())
    es.msg('#multi', '#green[#lightgreenES Hidden#green] #lightgreen- #greenMISSION EXECUTE #lightgreen-')
    es.cexec_all('play', 'hidden/IRIS-roundstart02.wav')

def declass():
    global new_class
    new_class = 0

def item_pickup(ev):
    if ev['item'] != 'knife' and ev['es_userteam'] == '2':
        strip_player(ev)
        gamethread.delayed(0, es.server.queuecmd, ('es_xgive %s weapon_knife' % ev['userid']))

def player_spawn(ev):
    global chosen, msg, ranks
    userid = ev['userid']
    user = playerlib.uniqueid(ev['userid'], True)
    es.server.queuecmd('es_xfire %s func_buyzone Disable' % ev['userid'])
    es.server.queuecmd('es_xfire %s func_bomb_target Disable' % ev['userid'])
    es.server.queuecmd('es_xfire %s func_hostage_rescue Disable' % ev['userid'])
    es.server.queuecmd('est_RemoveIdle cs_ragdoll')
    es.server.queuecmd('est_RemoveIdle weapon')
    es.server.queuecmd('est_Remove hostage_entity')
    es.server.queuecmd('est_RemoveWeapon #t 5')
    player = playerlib.getPlayer(ev['userid'])
    if ev['es_steamid'] != 'BOT':
        chosen[user]['spawns'] += 1
    if ev['es_userteam'] == '2':
        if es.getplayercount(2) > 1:
            gamethread.delayed(.1, es.changeteam, (ev['userid'], '3'))
            es.tell(ev['userid'], '#multi', '#green[#lightgreenES Hidden#green] #defaultThere can only be #lightgreenONE #greenHidden#lightgreen!')
        elif es.getplayercount(2) == 1:
            es.centertell(ev['userid'], 'You are the Hidden! Rescue yourself!')
            gamethread.delayed(1, es.centertell, (ev['userid'], 'You are the Hidden! Rescue yourself!'))
            gamethread.delayed(2, es.centertell, (ev['userid'], 'You are the Hidden! Rescue yourself!'))
            player.set('speed', hidden_speed)
            player.set('health', hidden_health)
            strip_player(ev)
            player.set('color', (255, 255, 255, 19))
            player.set('weaponcolor', (0, 0, 0, 0))
            if ev['es_steamid'] != 'BOT':
                ranks[user]['hidden_times'] += 1
                if ranks[user]['roundkills'] == es.getplayercount(3) / 2:
                    player.set('health', hidden_health + int(hidden_health) / 2)
                    es.tell(userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultYou get #green%s #lightgreenHP #defaultfor killing #lightgreen%s #greenIRIS Forces#default.' % (int(hidden_health) / 2, ranks[user]['roundkills']))
                elif ranks[user]['roundkills'] == es.getplayercount(3):
                    player.set('health', hidden_health + int(hidden_health))
                    es.tell(userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultYou get #green%s #lightgreenHP #defaultfor killing #lightgreen%s #greenIRIS Forces#default.' % (hidden_health, ranks[user]['roundkills']))
                ranks[user]['roundkills'] = 0
    elif ev['es_userteam'] == '3':
        if es.getplayercount(2) == 1:
            es.centertell(ev['userid'], '617 has been spotted in this sector - MOVE OUT!')
            gamethread.delayed(1, es.centertell, (ev['userid'], '617 has been spotted in this sector - MOVE OUT!'))
            gamethread.delayed(2, es.centertell, (ev['userid'], '617 has been spotted in this sector - MOVE OUT!'))
            player.set('color', (255, 255, 255, 255))
            if ev['es_steamid'] == 'BOT':
                prim = random.choice(str(bot_wep_prim).split(';'))
                sec = random.choice(str(bot_wep_sec).split(';'))
                es.server.queuecmd('es_xgive %s %s;es_xgive %s %s' % (ev['userid'], sec, ev['userid'], prim))
            else:
                if chosen[user]['spawns'] == 2:
                    es.tell(ev['userid'], '#multi', '#green[#lightgreenES Hidden#green] #defaultType #green!class #defaultto choose a new class.')
                elif chosen[user]['spawns'] == 4:
                    es.tell(ev['userid'], '#multi', '#green[#lightgreenES Hidden#green] #defaultPress #greenN #defaultto turn on #lightgreenLight Amplification Goggles')
                    chosen[user]['spawns'] = 0
                if chosen[user]['class'] != 0:
                    strip_player(ev)
                    gamethread.delayed(0, es.server.queuecmd, ('es_xgive %s item_nvgs' % ev['userid']))
                    gamethread.delayed(0, es.server.queuecmd, ('es_xgive %s %s;es_xgive %s %s' % (ev['userid'], chosen[user]['sec'], ev['userid'], chosen[user]['prim'])))
                    if chosen[user]['class'] == 'assault':
                        player.set('health', 75)
                    elif chosen[user]['class'] == 'support':
                        player.set('health', 125)
                else:
                    default(user)
                    classes.send(ev['userid'])

def player_disconnect(ev):
    global ranks
    default(user)
    ranks[user]['roundkills'] = 0

def round_end(ev):
    es.server.queuecmd('est_RemoveIdle cs_ragdoll')
    es.server.queuecmd('est_RemoveIdle weapon')

def strip_player(ev):
    es.server.queuecmd('es_xfire %s player_weaponstrip kill' % ev['userid'])
    es.server.queuecmd('es_xgive %s player_weaponstrip' % ev['userid'])
    es.server.queuecmd('es_xfire %s player_weaponstrip strip' % ev['userid'])
    gamethread.delayed(0, es.server.queuecmd, ('es_xgive %s item_assaultsuit;es_xgive %s weapon_knife' % (ev['userid'], ev['userid'])))

def player_activate(ev):
    if ev['es_steamid'] != 'BOT':
        user = playerlib.uniqueid(ev['userid'], True)
        if not user in chosen:
            default(user)
        if not user in ranks:
            rank(user)

def rank(user):
    global ranks
    ranks[user] = {}
    ranks[user]['kills'] = 0
    ranks[user]['roundkills'] = 0
    ranks[user]['deaths_hidden'] = 0
    ranks[user]['hidden_times'] = 0
    ranks[user]['deaths_iris'] = 0
    ranks[user]['kills_iris'] = 0

def default(user):
    global chosen
    chosen[user] = {}
    chosen[user]['spawns'] = 0
    chosen[user]['class'] = 0
    chosen[user]['prim'] = 0
    chosen[user]['sec'] = 0
    chosen[user]['addition'] = 0

def player_team(ev):
    user = playerlib.uniqueid(ev['userid'], True)
    if ev['team'] == '2':
        if es.getplayercount(2) > 1:
            es.sexec(ev['userid'], 'kill')
            es.server.queuecmd('est_Team %s 3' % ev['userid'])
            es.server.queuecmd('est_Spawn %s' % ev['userid'])
            es.tell(ev['userid'], '#multi', '#green[#lightgreenES Hidden#green] #defaultThere can only be #lightgreenONE #greenHidden#lightgreen!')

def player_hurt(ev):
    player = playerlib.getPlayer(ev['userid'])
    if ev['es_userteam'] == '2':
        if ev['dmg_health'] <= '20':
            player.add('health', int(ev['dmg_health']) - 13)
        elif ev['dmg_health'] <= '50':
            player.add('health', int(ev['dmg_health']) - 25)
        elif ev['dmg_health'] <= '80':
            player.add('health', int(ev['dmg_health']) - 50)

def player_death(ev):
    global ranks
    es.server.queuecmd('est_RemoveIdle cs_ragdoll')
    es.server.queuecmd('est_RemoveIdle weapon')
    attacker = playerlib.uniqueid(ev['attacker'], True)
    victim = playerlib.uniqueid(ev['userid'], True)
    player = playerlib.getPlayer(ev['attacker'])
    if ev['es_userteam'] == '2' and ev['es_attackerteam'] == '3':
        es.server.queuecmd('est_RemoveIdle cs_ragdoll')
        es.server.queuecmd('est_RemoveIdle weapon')
        es.server.queuecmd('est_Remove hostage_entity')
        es.server.queuecmd('est_RemoveWeapon #t 5')
        if ev['es_steamid'] != 'BOT':
            ranks[victim]['deaths_hidden'] += 1
        if ev['es_attackersteamid'] != 'BOT':
            ranks[attacker]['kills_iris'] += 1
        for cts in playerlib.getUseridList('#ct'):
            es.cexec(cts, 'playgamesound', 'hidden/IRIS-roundend06.wav')
        hidden_death = random.choice(death_hidden)
        es.cexec(ev['userid'], 'playgamesound', hidden_death)
        es.server.queuecmd('est_Team %s 2;est_Team %s 3' % (ev['attacker'], ev['userid']))
        es.sexec(ev['attacker'], 'kill')
        es.server.queuecmd('est_Spawn %s' % ev['userid'])
        es.msg('#multi', '#green[#lightgreenES Hidden#green] %s #lightgreenis now the #greenHidden#lightgreen!' % es.getplayername(ev['attacker']))
    elif ev['es_userteam'] == '3' and ev['es_attackerteam'] == '2':
        if ev['es_attackersteamid'] != 'BOT':
            ranks[attacker]['kills'] += 1
            ranks[attacker]['roundkills'] += 1
        if ev['es_steamid'] != 'BOT':
            ranks[victim]['deaths_iris'] += 1
        player.set('speed', hidden_speed + 0.3)
        player.add('health', int(hidden_health) / int(additional_hidden_health))
        es.msg('#multi', '#green[#lightgreenES Hidden#green] Hidden #lightgreen%s #defaultgot #green%s #lightgreenHP #defaultfor killing #green%s' % (es.getplayername(ev['attacker']), hidden_health / int(additional_hidden_health), es.getplayername(ev['userid'])))
        sound = random.choice(sounds)
        es.cexec_all('play', sound)
        iris_death = random.choice(death_iris)
        es.cexec(ev['userid'], 'playgamesound', iris_death)
